#
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
#
class hdp::snmp(
  $service_state = 'running'
)
{
  include hdp::params

  hdp::package {'snmp':}

  hdp::snmp-configfile {'snmpd.conf': 
    notify => Service['snmpd']    
  }

  service { 'snmpd' :
    ensure => $service_state
  }

  exec { "snmpd_autostart" :
    command => "chkconfig snmpd on",
    path => '/usr/sbin:/sbin:/usr/local/bin:/bin:/usr/bin',
  }
 
  anchor{'hdp::snmp::begin':} -> Hdp::Package['snmp'] -> Hdp::Snmp-configfile<||> -> Service['snmpd'] -> Exec['snmpd_autostart'] -> anchor{'hdp::snmp::end':}
}

define hdp::snmp-configfile()
{ 
  hdp::configfile { "${hdp::params::snmp_conf_dir}/${name}":
    component     => 'base',
    owner         => root,
    group         => root
  }
}

